<?php
require_once( "../../db.php" );
//require_once( "useSingleton.php" );
/**
 * Methods for database handling.
 */
class Stock extends Db  {

   
    public $name;
    public $address;
    public  $phone;
    public $date;
	
	
	 
	 
	 public function __construct() {

   }


   public function addSupplier($name, $address, $date, $phone){

     
    try{
		   
		   
        $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
         
        $sql = 'INSERT INTO suppliers (name,address,date,phone)
                VALUES (:name, :address,:date, :phone)';

       
         
        $statement = $MySQLiconn->prepare($sql);
         $statement->bindValue(':name', $name);
        $statement->bindValue(':address', $address);
        $statement->bindValue(':date', $date);
        $statement->bindValue(':phone', $phone);
        
        
        $statement->execute();

        parent::DisConnect( $MySQLiconn);	 
            
            
            
             
             
             }
             
             catch(Exception $e){
            echo "oops! ".$e->getMessage(); 
            
            } 
            
   }


   public function findSuppliersByID($id){
			
    $instance = parent::getInstance();	
$MySQLiconn  = $instance->getConnection();
    
    try {
    $sql = "SELECT * from suppliers WHERE id =:id";
    
    $statement = $MySQLiconn->prepare($sql);
    
    $statement->bindValue(':id',$id);
     $statement->execute();
  $row = $statement->fetch(PDO::FETCH_ASSOC);  
  $this->name = $row['name'];
  $this->address = $row['address'];
  $this->phone = $row['phone'];
  $this->date = $row['date'];
    parent::DisConnect( $MySQLiconn);	

    }
    catch(Exception $e){
        echo "oops! ".$e->getMessage(); 
        
        } 

    }	


    public function updateSuppliers($id,$name, $address, $date, $phone){

     
        try{
               
               
            $instance = parent::getInstance();
            // $instance = new DBAccess();
         $MySQLiconn  = $instance->getConnection();
             
            $sql = "UPDATE suppliers set name = :name, address = :address, phone = :phone, date = :date 
            where id = :id ";
    
           
             
            $statement = $MySQLiconn->prepare($sql);
            $statement->bindValue(':id', $id);
             $statement->bindValue(':name', $name);
            $statement->bindValue(':address', $address);
            $statement->bindValue(':date', $date);
            $statement->bindValue(':phone', $phone);
            
            
            $statement->execute();
    
            parent::DisConnect( $MySQLiconn);	 
                
                
                
                 
                 
                 }
                 
                 catch(Exception $e){
                echo "oops! ".$e->getMessage(); 
                
                } 
            }
             
                public function getAllSuppliers(){
	 
                    $instance = parent::getInstance();
                      // $instance = new DBAccess();
                   $MySQLiconn  = $instance->getConnection();
                   
                   $sql = 	"SELECT  * FROM suppliers ";
                   
                   
                   $statement = $MySQLiconn->prepare($sql);
                      
                    
                      $statement->execute();
                      
                      return $statement;
                     
                       parent::DisConnect( $MySQLiconn); 
                   
                   } 

                  
                   public function checkSuppliers($name){
	 
                    $instance = parent::getInstance();
                      // $instance = new DBAccess();
                   $MySQLiconn  = $instance->getConnection();
                   
                   $sql = 	"SELECT  * FROM suppliers where name = :name ";
                   
                   
                   $statement = $MySQLiconn->prepare($sql);
                   $statement->bindValue(':name', $name);  
                    
                      $statement->execute();
                      
                      $num = $statement->rowCount();
	 
 
    return $num;
                     
                       parent::DisConnect( $MySQLiconn); 
                   
                   }   
                
                
       public function deleteSupplier($id){

        
        $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
     $sql = 	"DELETE FROM suppliers where id = :id ";
     
     
     $statement = $MySQLiconn->prepare($sql);
     $statement->bindValue(':id', $id);  
      
        $statement->execute();

       }


       public function createStock($stock_id,$name, $selling_price, $cost_price,$date_updated,
       $supplier_id,$descp){

     
        try{
               
               
            $instance = parent::getInstance();
            // $instance = new DBAccess();
         $MySQLiconn  = $instance->getConnection();
             
            $sql = 'INSERT INTO stock (stock_id,name,selling_price,cost_price,date_updated,
            supplier_id,descp)
                    VALUES (:stock_id, :name, :selling_price, :cost_price, :date_updated, :supplier_id, :descp)';
    
           
             
            $statement = $MySQLiconn->prepare($sql);
            $statement->bindValue(':stock_id', $stock_id);
         
             $statement->bindValue(':name', $name);
            $statement->bindValue(':selling_price', $selling_price);
            $statement->bindValue(':cost_price', $cost_price);
            $statement->bindValue(':date_updated', $date_updated);
            $statement->bindValue(':supplier_id', $supplier_id);
            $statement->bindValue(':descp', $descp);
            $statement->execute();
    
            parent::DisConnect( $MySQLiconn);	 
                
                
                
                 
                 
                 }
                 
                 catch(Exception $e){
                echo "oops! ".$e->getMessage(); 
                
                } 
                
       }


      
       
       public function addStockAvailable($stock_id, $quantity, $date_updated){

     
        try{
               
               
            $instance = parent::getInstance();
            // $instance = new DBAccess();
         $MySQLiconn  = $instance->getConnection();
             
            $sql = 'INSERT INTO stock_available (stock_id,quantity,date_updated)
                    VALUES (:stock_id, :quantity,  :date_updated)';
    
         
            $statement = $MySQLiconn->prepare($sql);
            $statement->bindValue(':stock_id', $stock_id);
            $statement->bindValue(':quantity', $quantity);
            $statement->bindValue(':date_updated', $date_updated);
          
            
            $statement->execute();
    
            parent::DisConnect( $MySQLiconn);	 
                
                
                
                 
                 
                 }
                 
                 catch(Exception $e){
                echo "oops! ".$e->getMessage(); 
                
                } 
                
       }


    
    
       public function addStock($stock_id, $quantity, $date_updated){

     
        try{
               
               
            $instance = parent::getInstance();
            // $instance = new DBAccess();
         $MySQLiconn  = $instance->getConnection();
             
            $sql = "UPDATE stock_available set quantity = :quantity, date_updated = :date_updated WHERE stock_id =
            :stock_id";
    
         
            $statement = $MySQLiconn->prepare($sql);
            $statement->bindValue(':stock_id', $stock_id);
            $statement->bindValue(':quantity', $quantity);
            $statement->bindValue(':date_updated', $date_updated);
          
            
            $statement->execute();
    
            parent::DisConnect( $MySQLiconn);	 
                
                  
                 }
                 
                 catch(Exception $e){
                echo "oops! ".$e->getMessage(); 
                
                } 
                
       }

       public function checkStock($name,$stock_id){
	 
         $instance = parent::getInstance();
           // $instance = new DBAccess();
        $MySQLiconn  = $instance->getConnection();
        
        $sql = 	"SELECT  * FROM stock where name = :name AND  stock_id = :stock_id ";
        
        
        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':name', $name);  
        $statement->bindValue(':stock_id', $stock_id);  
         
           $statement->execute();
           
           $num = $statement->rowCount();


return $num;
          
            parent::DisConnect( $MySQLiconn); 
        
        }   
     
      
        public function getAllStock(){
	 
         $instance = parent::getInstance();
           // $instance = new DBAccess();
        $MySQLiconn  = $instance->getConnection();
        
        $sql = 	"SELECT  s.id,s.name,s.cost_price,s.selling_price,s.descp,s.stock_id,w.name AS supplier_name
        FROM stock s INNER JOIN suppliers w ON supplier_id = w.id ";
        
        
        $statement = $MySQLiconn->prepare($sql);
           
         
           $statement->execute();
           
           return $statement;
          
            parent::DisConnect( $MySQLiconn); 
        
        } 


        public function deleteStock($id){

        
         $instance = parent::getInstance();
         // $instance = new DBAccess();
      $MySQLiconn  = $instance->getConnection();
      
      $sql = 	"DELETE FROM stock where id = :id ";
      
      
      $statement = $MySQLiconn->prepare($sql);
      $statement->bindValue(':id', $id);  
       
         $statement->execute();
 
        }


        public function findStockByID($stock_id){
			
         $instance = parent::getInstance();	
     $MySQLiconn  = $instance->getConnection();
         
         try {
         $sql = "SELECT * from stock WHERE stock_id =:stock_id";
         
         $statement = $MySQLiconn->prepare($sql);
         
         $statement->bindValue(':stock_id',$stock_id);
          $statement->execute();
       $row = $statement->fetch(PDO::FETCH_ASSOC); 
       $this->id = $row['id']; 
       $this->name = $row['name'];
       $this->descp = $row['descp'];
       $this->cost_price = $row['cost_price'];
       $this->selling_price = $row['selling_price'];
       $this->supplier_id = $row['supplier_id'];
       $this->date_updated = $row['date_updated'];
         parent::DisConnect( $MySQLiconn);	
     
         }
         catch(Exception $e){
             echo "oops! ".$e->getMessage(); 
             
             } 
     
         }	
         
     
     
         public function updateStock($stock_id,$name, $selling_price, $cost_price,$date_updated,
       $supplier_id,$descp){

     
        try{
               
               
            $instance = parent::getInstance();
            // $instance = new DBAccess();
         $MySQLiconn  = $instance->getConnection();
             
            $sql = "UPDATE stock set name = :name, selling_price = :selling_price, cost_price = :cost_price,
            date_updated = :date_updated, supplier_id = :supplier_id, descp = :descp WHERE  stock_id = :stock_id ";
    
           
             
            $statement = $MySQLiconn->prepare($sql);
            $statement->bindValue(':stock_id', $stock_id);
         
             $statement->bindValue(':name', $name);
            $statement->bindValue(':selling_price', $selling_price);
            $statement->bindValue(':cost_price', $cost_price);
            $statement->bindValue(':date_updated', $date_updated);
            $statement->bindValue(':supplier_id', $supplier_id);
            $statement->bindValue(':descp', $descp);
            $statement->execute();
    
            parent::DisConnect( $MySQLiconn);	 
                
                
                
                 
                 
                 }
                 
                 catch(Exception $e){
                echo "oops! ".$e->getMessage(); 
                
                } 
                
       }



       public function findStockQuantityByID($stock_id){
			
         $instance = parent::getInstance();	
     $MySQLiconn  = $instance->getConnection();
         
         try {
         $sql = "SELECT * from stock_available WHERE stock_id =:stock_id";
         
         $statement = $MySQLiconn->prepare($sql);
         
         $statement->bindValue(':stock_id',$stock_id);
          $statement->execute();
       $row = $statement->fetch(PDO::FETCH_ASSOC); 
       $this->quantity = $row['quantity']; 
       $this->date_updated = $row['date_updated']; 
         parent::DisConnect( $MySQLiconn);	
     
         }
         catch(Exception $e){
             echo "oops! ".$e->getMessage(); 
             
             } 
     
         }	
         

 
         public function addStockRecord($stock_id, $name,$supplier_id, $quantity,$date){

     
            try{
                   
                   
                $instance = parent::getInstance();
                // $instance = new DBAccess();
             $MySQLiconn  = $instance->getConnection();
                 
                $sql = 'INSERT INTO stock_record (stock_id, name, supplier_id,quantity,date)
                        VALUES (:stock_id, :name, :supplier_id, :quantity,  :date)';
        
             
                $statement = $MySQLiconn->prepare($sql);
                $statement->bindValue(':stock_id', $stock_id);
                $statement->bindValue(':name', $name);
                $statement->bindValue(':supplier_id', $supplier_id);
                $statement->bindValue(':quantity', $quantity);
                $statement->bindValue(':date', $date);
              
                
                $statement->execute();
        
                parent::DisConnect( $MySQLiconn);	 
                    
                    
                    
                     
                     
                     }
                     
                     catch(Exception $e){
                    echo "oops! ".$e->getMessage(); 
                    
                    } 
                    
           }

        // new codes
        
        public function getAllStockBYID($stock_id){
	 
         $instance = parent::getInstance();
           // $instance = new DBAccess();
        $MySQLiconn  = $instance->getConnection();
        
        $sql = 	"SELECT  s.id,s.name,s.cost_price,s.selling_price,s.descp,s.stock_id,w.name AS supplier_name
        FROM stock s INNER JOIN suppliers w ON supplier_id = w.id  WHERE s.stock_id = :stock_id ";
        
        
        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':stock_id', $stock_id);   
         
           $statement->execute();
           
           return $statement;
          
            parent::DisConnect( $MySQLiconn); 
        
        } 

     
        public function checkStockExixtence($stock_id){
	 
         $instance = parent::getInstance();
           // $instance = new DBAccess();
        $MySQLiconn  = $instance->getConnection();
        
        $sql = "SELECT * from stock_available WHERE stock_id =:stock_id";
        
        
        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':stock_id', $stock_id);  
         
           $statement->execute();
           
           $num = $statement->rowCount();


return $num;
          
            parent::DisConnect( $MySQLiconn); 
        
        }  


        public function AddSalesOrder($transid, $date, $studname, $amount,$class,$profit,$staffid){

     
         try{
                
                
             $instance = parent::getInstance();
             // $instance = new DBAccess();
          $MySQLiconn  = $instance->getConnection();
              
             $sql = 'INSERT INTO sales_order (transid, date, studname,amount,class,profit,staffid)
                     VALUES (:transid, :date, :studname, :amount,  :class, :profit, :staffid)';
     
          
             $statement = $MySQLiconn->prepare($sql);
             $statement->bindValue(':transid', $transid);
             $statement->bindValue(':date', $date);
             $statement->bindValue(':studname', $studname);
             $statement->bindValue(':amount', $amount);
             $statement->bindValue(':class', $class);
             $statement->bindValue(':profit', $profit);
             $statement->bindValue(':staffid', $staffid);
             
             $statement->execute();
     
             parent::DisConnect( $MySQLiconn);	 
                 
                 
                 
                  
                  
                  }
                  
                  catch(Exception $e){
                 echo "oops! ".$e->getMessage(); 
                 
                 } 
                 
        }


        public function findSalesOrder($date1,$date2){
	 
         $instance = parent::getInstance();
           // $instance = new DBAccess();
        $MySQLiconn  = $instance->getConnection();
        
        $sql = "SELECT * from sales_order WHERE date   between  '".$date1."' AND '".$date2."'  ";
        
        
        $statement = $MySQLiconn->prepare($sql);
      
         
           $statement->execute();
           
          return $statement;
          
            parent::DisConnect( $MySQLiconn); 
        
        }  

     // new codes

     public function getAllStockForSale(){
	 
      $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
     $sql = 	"SELECT  s.id,s.name,s.cost_price,s.selling_price,s.descp,s.stock_id,w.name AS supplier_name, v.quantity
     FROM stock s INNER JOIN suppliers w ON s.supplier_id = w.id 
     INNER JOIN stock_available v on s.stock_id = v.stock_id where v.quantity > 0 ";
     
     
     $statement = $MySQLiconn->prepare($sql);
        
      
        $statement->execute();
        
        return $statement;
       
         parent::DisConnect( $MySQLiconn); 
     
     } 


  
     public function findSalesOrderByStaffId($date1,$date2,$staffid){
	 
      $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
     $sql = "SELECT * from sales_order WHERE staffid = :staffid AND date   between  '".$date1."' AND '".$date2."'  ";
     
     
     $statement = $MySQLiconn->prepare($sql);
     $statement->bindValue(':staffid', $staffid);
   
      
        $statement->execute();
        
       return $statement;
       
         parent::DisConnect( $MySQLiconn); 
     
     }  
     
     
     public function getAllStockViaTrans($transid){
	 
      $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
     $sql = 	"SELECT  * FROM stock_trans where transid = :transid ";
     
     
     $statement = $MySQLiconn->prepare($sql);
     $statement->bindValue(':transid', $transid);  
      
        $statement->execute();
        
       // $num = $statement->rowCount();
   return $statement;

   //return $num;
       
         parent::DisConnect( $MySQLiconn); 
     
     }   
     
     
     

     public function getCategoriesByStockID($stock_id){
	 
      $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
   $sql = 	"SELECT  w.name,p.price,p.date,p.category,p.id
     FROM price_category p INNER JOIN stock w ON p.stock_id = w.stock_id  WHERE p.stock_id = :stock_id ";
     
     
     $statement = $MySQLiconn->prepare($sql);
     $statement->bindValue(':stock_id', $stock_id);   
      
        $statement->execute();
        
        return $statement;
       
         parent::DisConnect( $MySQLiconn); 
     
     } 

     // find price category by ID

     public function findPriceCategoryByID($id){
      
      $instance = parent::getInstance();	
  $MySQLiconn  = $instance->getConnection();
      
      try {
      $sql = "SELECT * from price_category WHERE id =:id";
      
      $statement = $MySQLiconn->prepare($sql);
      
      $statement->bindValue(':id',$id);
       $statement->execute();
    $row = $statement->fetch(PDO::FETCH_ASSOC); 
   
    $this->date = $row['date']; 
    $this->price = $row['price']; 
    $this->category = $row['category']; 
    $this->stock_id = $row['stock_id']; 
      parent::DisConnect( $MySQLiconn);	
  
      }
      catch(Exception $e){
          echo "oops! ".$e->getMessage(); 
          
          } 
  
      }	
      
      
       public function getAllStockViaTransViaDate($date1,$date2){
	 
      $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
     $sql = 	"SELECT  * FROM stock_trans where  date   between  '".$date1."' AND '".$date2."' ";
     
     
     $statement = $MySQLiconn->prepare($sql);
     
      
        $statement->execute();
        
       // $num = $statement->rowCount();
   return $statement;

   //return $num;
       
         parent::DisConnect( $MySQLiconn); 
     
     }   
     
       public function getAllStockDetailsViaTrans($code1){
	 
      $instance = parent::getInstance();
        // $instance = new DBAccess();
     $MySQLiconn  = $instance->getConnection();
     
     $sql = 	"SELECT  * FROM stock_sales where code1 = :code1 ";
     
     
     $statement = $MySQLiconn->prepare($sql);
     $statement->bindValue(':code1', $code1);  
      
        $statement->execute();
        
       // $num = $statement->rowCount();
   return $statement;

   //return $num;
       
         parent::DisConnect( $MySQLiconn); 
     
     }  
     
     
       public function deleteStockSales($code1){

        
         $instance = parent::getInstance();
         // $instance = new DBAccess();
      $MySQLiconn  = $instance->getConnection();
      
      $sql = 	"DELETE FROM stock_sales where code1 = :code1 ";
      
      
      $statement = $MySQLiconn->prepare($sql);
      $statement->bindValue(':code1', $code1);  
       
         $statement->execute();
 
        }

 public function deleteStockSales1($code1){

        
         $instance = parent::getInstance();
         // $instance = new DBAccess();
      $MySQLiconn  = $instance->getConnection();
      
      $sql = 	"DELETE FROM stock_sales where code1 = :code1 ";
      
      
      $statement = $MySQLiconn->prepare($sql);
      $statement->bindValue(':code1', $code1);  
       
         $statement->execute();
 
        }
        
    
     public function deleteStockSalesTrans($code1){

        
         $instance = parent::getInstance();
         // $instance = new DBAccess();
      $MySQLiconn  = $instance->getConnection();
      
      $sql = 	"DELETE FROM stock_trans where code1 = :code1 ";
      
      
      $statement = $MySQLiconn->prepare($sql);
      $statement->bindValue(':code1', $code1);  
       
         $statement->execute();
 
        }
        
        
    public function deleteStockSalesOrder($transid){

        
         $instance = parent::getInstance();
         // $instance = new DBAccess();
      $MySQLiconn  = $instance->getConnection();
      
      $sql = 	"DELETE FROM sales_order where transid = :transid ";
      
      
      $statement = $MySQLiconn->prepare($sql);
      $statement->bindValue(':transid', $transid);  
       
         $statement->execute();
 
        }  
        
        
        
        
        // find transaction by code
        
          public function findTransactionByCode($code1){
      
      $instance = parent::getInstance();	
  $MySQLiconn  = $instance->getConnection();
      
      try {
      $sql = "SELECT * from transaction WHERE code1 =:code1";
      
      $statement = $MySQLiconn->prepare($sql);
      
      $statement->bindValue(':code1',$code1);
       $statement->execute();
    $row = $statement->fetch(PDO::FETCH_ASSOC); 
   
    
    $this->mode = $row['mode']; 
    $this->amount = $row['amount']; 
   
      parent::DisConnect( $MySQLiconn);	
  
      }
      catch(Exception $e){
          echo "oops! ".$e->getMessage(); 
          
          } 
  
      }	
     
     
 
}   